/** common.h
*   project : xp3dumper
*   author  : resty
**/
#ifndef __common_h__included__
#define __common_h__included__

#include <windows.h>
#include <string>

extern TCHAR * title;

typedef struct {
	unsigned int open_archive;
	unsigned int arc_construct_begin;
	unsigned int arc_construct_end;
	unsigned int argument_delta;
} func_info;

extern HINSTANCE hDll;

extern int closed;

//unpack a arc
extern int seach_infomation(func_info* info);
extern void unpack_archive(unsigned int handle, const wchar_t * path);
void PngAddXp3(const wchar_t * name);

// user interface :
extern void (* print_log_screen) (const wchar_t* s, int reline = 1);
extern void (* update_last_info) (unsigned int finished, unsigned int total);
extern void (* print_log) (const wchar_t* s, int reline = 1);

// option setting
extern void SetOption(int item, int value);
extern int GetOption(int item);

// Options
#define OPT_TLG_TO_PNG 0

// some infomation : 
extern void set_dump_path(const wchar_t* s);
extern std::wstring get_dump_path();

//some useful function:
extern std::wstring int2str(int number);
extern std::wstring hex2str(unsigned int number);
extern std::wstring format_path(const wchar_t * path);

#endif
