#include "method.h"
#include "common.h"
#include "resource.h"
#include <set>

static HANDLE hStdOut;

func_info info;
std::set<std::wstring> proced;
unsigned int id;
wchar_t * _str;

int __declspec(naked) ready_work() {
	__asm {
		mov id, eax
		mov eax, ebp
		add eax, info.argument_delta
		mov eax, [eax]
		mov eax, [eax]
		mov eax, [eax+4]
		mov _str, eax
	}

	if (proced.find(_str) == proced.end()) {
		unsigned int i = 0;
		while (_str[i]) ++i;
		while (_str[i] != '\\' && _str[i] != '/') --i;
		PngAddXp3(_str+i+1);
		std::wstring tmp = std::wstring(get_dump_path() + (_str + i));
		proced.insert(_str);
		SetConsoleTextAttribute(hStdOut, FOREGROUND_GREEN);
		print_log_screen(_str+i+1,0);
		SetConsoleTextAttribute(hStdOut, FOREGROUND_INTENSITY);
		unpack_archive(id, tmp.c_str());
	} else {
	}

	__asm {
		pop ebx
		mov esp, ebp
		pop ebp
		mov eax, id
		ret
	}
}

static int last_pos_x = 0;
static int last_pos_y = 0;

static void updata_last_pos() {
	CONSOLE_SCREEN_BUFFER_INFO info;
	GetConsoleScreenBufferInfo(hStdOut, &info);
	last_pos_x = info.dwCursorPosition.X;
	last_pos_y = info.dwCursorPosition.Y;
}

void print_log_screen_hook (const wchar_t* s, int reline) {
	DWORD tmp, tmp2;
	std::wstring str = s;
	if (reline) {
		str += TEXT("\r\n");
	}
	WriteConsole(hStdOut, str.c_str(), str.size(), &tmp, &tmp2);
	updata_last_pos();
}

void update_last_info_hook (unsigned int finished, unsigned int total){
	std::wstring res = int2str(finished) + L" / " + int2str(total) + TEXT("   \r\n");
	COORD pos;
	pos.X = last_pos_x;
	pos.Y = last_pos_y;
	SetConsoleCursorPosition(hStdOut,pos);
	DWORD tmp, tmp2;
	WriteConsole(hStdOut, res.c_str(), res.size(), &tmp, &tmp2);
}

void start_hook() {
	if (seach_infomation(&info) != 0) {
		print_log(L"failed when search infomation.");
		return ;
	}
	print_log(L"method 1 - Infomations:");
	print_log((L"delta = " + int2str(info.argument_delta)).c_str());
	print_log((L"construct func = 0x" + hex2str(info.arc_construct_begin)).c_str());
	print_log((L"hook place :  0x" + hex2str(info.arc_construct_end)).c_str());
	print_log(L"");

	DWORD old;
	VirtualProtect((void*)(info.arc_construct_end-4), 5, PAGE_EXECUTE_READWRITE ,&old);
	unsigned char * point =  (unsigned char *)(info.arc_construct_end-4);
	point[0] = 0xe9;
	*(DWORD*)(point+1) = (DWORD)ready_work - info.arc_construct_end - 1;
	VirtualProtect((void*)(info.arc_construct_end-4), 5, old ,&old);

	AllocConsole();
	hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
	freopen("CONOUT$", "w", stdout);
	printf("xp3dumper - hook mode.\n");
	print_log_screen = print_log_screen_hook;
	update_last_info = update_last_info_hook;
}
